/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+,78K0S/KU1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.70 [7 Dec. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "int.h"
#include "port.h"
#include "timer.h"
#include "watchdogtimer.h"
#include "lvi.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/

unsigned char	moji_p;
unsigned char	move_flg;
unsigned char	move_cnt;
unsigned char	start_key;
unsigned char	start_rep;
unsigned char	start_cnt;
unsigned char	led_data;
unsigned char	key_count;
unsigned char	kido;
unsigned char	kotae;
unsigned char	data[8]={ 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80 };

void	time_wait(unsigned int time)
{
	while(time!=0){
	time--;
	}
}

void	led_port_clear(void)
{
		P4.0=1;
		P2.1=1;
		P2.2=1;
		P2.3=1;
		P4.2=1;
		P4.3=1;
		P4.4=1;
		P4.5=1;
}
void	led_wait_1(unsigned char n)
{
		switch(n){
			case 0:time_wait(500);break;
			case 1:time_wait(300);break;
			case 2:time_wait(100);break;
			case 3:time_wait(50);break;
		}
}
void	led_wait_2(unsigned char n)
{
		switch(n){
			case 0:time_wait(1);break;
			case 1:time_wait(200);break;
			case 2:time_wait(400);break;
			case 3:time_wait(450);break;
		}
}
void	led_disp(void)
{
		if((led_data&0x01)==0x01){P4.0=0;}
		if((led_data&0x02)==0x02){P2.1=0;}
		if((led_data&0x04)==0x04){P2.2=0;}
		if((led_data&0x08)==0x08){P2.3=0;}
		if((led_data&0x10)==0x10){P4.5=0;}
		if((led_data&0x20)==0x20){P4.4=0;}
		if((led_data&0x40)==0x40){P4.3=0;}
		if((led_data&0x80)==0x80){P4.2=0;}
		
		led_wait_1(kido);
		led_port_clear();
		led_wait_2(kido);
}

void	main( void )
{

	moji_p=0;
	move_flg=0;
	move_cnt=11;

	start_key=1;
	start_rep=0;
	start_cnt=0;
	led_data=0;
	
	key_count=0;
	kido=0;

	led_port_clear();
	
	/* TODO. add user code */
	TM00_Start();
	while(1){

		if (P4.1==0){
				start_key=0;
		}
		else{
			start_key=1;
			start_rep=0;
			start_cnt=0;
		}

		led_disp();

		if ((P4.1==0)&(start_key==0)){
			start_key=0;
		}
		else{
			start_key=1;
			start_rep=0;
			start_cnt=0;
		}
	
		if((start_key==0)&(start_rep==0)){
			if(move_flg==0){
			
				time_wait(100);
				while(P4.1==0){
					key_count++;
				}
			
				kotae=data[key_count%8];
				moji_p=0;
				start_rep=1;
				move_cnt=11;
				move_flg=1;
				led_data=0x01;
				kido=0;
				led_port_clear();
				P13.0=1;
			}
		}
		
		if((move_flg==0)&&(P4.1==1)){
			P13.0=0;
			led_port_clear();
			led_data=0;
			STOP();
		}
	
	}
}

